/*
 * Nenad Taskovic 5/93
 * e-mail: neyt@fon.bg.ac.yu
 * www: http://fon.fon.bg.ac.yu/~neyt/
 */


/* konstante za funkcije `find_node', `do_forward' i `do_backward' */
#define RETURN   0  /* slog pronadjen, pretraga zavrsena           */
#define CONTINUE 1  /* slog nije pronadjen, pretraga se nastavlja  */
#define FOUND    2  /* slog pronadjen, pretraga se nastavlja       */

typedef struct Node {
   void *info;
   struct Node *prev, *next;
} Node;

typedef struct List {
   Node *head, *tail;
   unsigned int size;
} List;

List *init_list (unsigned int size);
void destroy_list (List *list);
void insert_at_head (List *list, void *info);
void insert_at_tail (List *list, void *info);
void do_node (Node *node, int (*)(void *));
void do_forward (List *list, int (*)(void *));
void do_backward (List *list, int (*)(void *));
void delete_node (Node *node);
Node *find_node (List *list, void *key, int (*)(void *, const void *));
/*
 * Funkcija za poredjenje slogova treba da vrati:
 *  1 - ako je prvi slog veci,
 *  0 - ako su slogovi jednaki,
 * -1 - ako je drugi slog veci.
 * Ovo vazi za funkcije `insert_sorted' i `insert_unique_sorted'.
 */
void insert_sorted (List *list, void *info, int (*)(const void *, const void *));
int insert_unique_sorted (List *list, void *info, int (*compare)(const void *, const void *));
/* funkcija `insert_unique_sorted' ubacuje u listu samo razlicite slogove (sa razlicitim kljucevima)
 * ukoliko je ubacivanje uspelo vraca vrednost razlicitu od 0 a u suprotnom vraca 0. */
