/*
 * Nenad Taskovic 5/93
 * e-mail: neyt@fon.bg.ac.yu
 * www: http://fon.fon.bg.ac.yu/~neyt/
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "liste.h"

typedef struct {
   int broj, godina;
} Indeks;

typedef struct Student {
   Indeks indeks;
   char prezime[16], ime[16];
   int semestar;
   float prosek;
} Student;

void report_error (const char *error)
{
   fprintf(stderr, "%s\n", error);
   exit(1);
}

int print (void *slog)
{
   printf("%4d/%2d %-15s %-15s %d %5.2f\n", ((Student *)slog)->indeks.broj,
	  ((Student *)slog)->indeks.godina, ((Student *)slog)->prezime, ((Student *)slog)->ime,
	  ((Student *)slog)->semestar, ((Student *)slog)->prosek);
   return (CONTINUE);
}

static float np = 100;
#ifdef __TURBOC__
	#pragma argsused
#endif
int najmanji_prosek (void *stud, const void *dummy)
{
   if ( ((Student *)stud)->prosek < np ) {
      np = ((Student *)stud)->prosek;
      return FOUND;
   }
   return CONTINUE;
}

int student_sa_indeksom (void *stud, const void *indx)
{
   if ( memcmp(stud, indx, sizeof(Indeks)) == 0 )
     return RETURN;
   else
     return CONTINUE;
}

int uporedi_prosek (const void *s1, const void *s2)
{
   return ( ( ((Student *)s1)->prosek > ((Student *)s2)->prosek ) ? 1 : -1 );
}

void meni (List *lista)
{
   int kraj = 0;
   char ch;
   Node *node;
   
   do {
      printf(" 1 - Stampanje svih studenata,\n");
      printf(" 2 - Pronalazenje studenta po indeksu,\n");
      printf(" 3 - Brisanje studenta po indeksu,\n");
      printf(" 4 - Student sa najmanjim prosekom,\n");
      printf(" 5 - Brisanje studenta sa najmanjim prosekom,\n");
      printf(" K - Kraj rada sa programom.\n");
      printf("\nVas izbor > ");
      scanf(" %c", &ch);
      printf("\n");
      switch (ch) {
       case '1':
	 do_forward(lista, print);
	 printf("\n");
	 break;
       case '2': {
	  Indeks indx;
	  
	  printf("Unesite broj indeksa > ");
	  scanf(" %d / %d", &indx.broj, &indx.godina);
	  printf("\n");
	  node = find_node(lista, (void *)&indx, student_sa_indeksom);
	  do_node(node, print);
	  printf("\n");
       } break;
       case '3': {
	  Indeks indx;
	  
	  printf("Unesite broj indeksa > ");
	  scanf(" %d / %d", &indx.broj, &indx.godina);
	  node = find_node(lista, (void *)&indx, student_sa_indeksom);
	  delete_node(node);
       } break;
       case '4':
	 np = 100;
	 node = find_node(lista, NULL, najmanji_prosek);
	 do_node(node, print);
	 printf("\n");
	 break;
       case '5':
	 np = 100;
	 node = find_node(lista, NULL, najmanji_prosek);
	 delete_node(node);
	 break;
       case 'K':
       case 'k':
	 kraj = 1;
	 break;
       default:
	 printf("Pogresan unos.\n\n");
      }
   } while (!kraj);
}

int main (int argc, char *argv[])
{
   Student stud;
   List *lista;
   FILE *f;
   int scanf_rez;
   
   if (argc >= 2) {
     if ( (f = fopen(argv[1], "rt")) == NULL )
	 report_error("Can't open input file");
   }
   else
     report_error("Usage: stud <name of the file with students data>");

   lista = init_list(sizeof(Student));

   while ( (scanf_rez = fscanf(f, " %d / %d %s %s %d %f", &stud.indeks.broj, &stud.indeks.godina,
			       stud.prezime, stud.ime, &stud.semestar, &stud.prosek)) == 6 )
      insert_sorted(lista, &stud, uporedi_prosek);
   if (scanf_rez != EOF)
	report_error("Error in structure of input file");
	   
   meni(lista);
   
   destroy_list(lista);

   return (0);
}
